## eccodes 2.34.1

=== CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#
###############################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

# Initialise project
project( eccodes LANGUAGES CXX )
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


###############################################################################
# system checks needed for eccodes_config.h and some options like MEMFS

check_type_size( int     ECCODES_SIZEOF_INT )
check_type_size( long    ECCODES_SIZEOF_LONG )
check_type_size( size_t  ECCODES_SIZEOF_SIZE_T )

check_include_files( assert.h      ECCODES_HAVE_ASSERT_H )
check_include_files( string.h      ECCODES_HAVE_STRING_H )
check_include_files( sys/types.h   ECCODES_HAVE_SYS_TYPES_H )
check_include_files( sys/stat.h    ECCODES_HAVE_SYS_STAT_H )
check_include_files( fcntl.h       ECCODES_HAVE_FCNTL_H )
check_include_files( unistd.h      ECCODES_HAVE_UNISTD_H )

check_symbol_exists( fseeko          "stdio.h"    ECCODES_HAVE_FSEEKO )
check_symbol_exists( posix_memalign  "stdlib.h"   ECCODES_HAVE_POSIX_MEMALIGN )
check_symbol_exists( fmemopen        "stdio.h"    ECCODES_HAVE_FMEMOPEN )
check_symbol_exists( funopen         "stdio.h"    ECCODES_HAVE_FUNOPEN )
check_symbol_exists( realpath        "stdlib.h"   ECCODES_HAVE_REALPATH )
check_symbol_exists( fsync           "unistd.h"   ECCODES_HAVE_FSYNC)
check_symbol_exists( fdatasync       "unistd.h"   ECCODES_HAVE_FDATASYNC)

check_c_source_compiles(
      " typedef int foo_t;
      static inline foo_t static_foo(){return 0;}
      foo_t foo(){return 0;}
      int main(int argc, char *argv[]){return 0;}
      " ECCODES_HAVE_C_INLINE
)

include(eccodes_test_endiness)
if( EC_OS_NAME MATCHES "windows" )
    include(eccodes_find_linux_utils)
endif()

ecbuild_debug("ECCODES_BIG_ENDIAN=${ECCODES_BIG_ENDIAN}")
ecbuild_debug("ECCODES_LITTLE_ENDIAN=${ECCODES_LITTLE_ENDIAN}")
ecbuild_info("Operating system=${CMAKE_SYSTEM} (${EC_OS_BITS} bits)")

# Only support 64 bit operating systems
if( NOT EC_OS_BITS EQUAL "64" )
    ecbuild_critical( "Operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) -- ecCodes only supports 64 bit platforms" )
endif()

###############################################################################
# some variables/options of this project

if( CMAKE_CXX_COMPILER_ID STREQUAL "GNU" )
    ecbuild_add_cxx_flags("-Wno-write-strings")
    ecbuild_add_cxx_flags("-Wno-deprecated")
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 16)
        ecbuild_add_cxx_flags("-Wno-write-strings")
        ecbuild_add_cxx_flags("-Wno-deprecated")
    else()
        ecbuild_add_cxx_flags("-Wno-writable-strings")
    endif()
elseif( CMAKE_CXX_COMPILER_ID STREQUAL "Cray" )
    set(CMAKE_CXX_FLAGS "-hstd=c++11 ${CMAKE_CXX_FLAGS}")
endif()

ecbuild_add_option( FEATURE PRODUCT_GRIB
    DESCRIPTION "Support for the product GRIB"
    DEFAULT ON )
ecbuild_add_option( FEATURE PRODUCT_BUFR
    DESCRIPTION "Support for the product BUFR"
    DEFAULT ON )
if( NOT HAVE_PRODUCT_GRIB AND NOT HAVE_PRODUCT_BUFR )
    ecbuild_critical("Cannot disable both GRIB and BUFR! Please specify just one option")
endif()

ecbuild_add_option( FEATURE EXAMPLES
    DESCRIPTION "Build the examples"
    DEFAULT ON )

ecbuild_add_option( FEATURE BUILD_TOOLS
    DESCRIPTION "Build the command line tools"
    DEFAULT ON )

ecbuild_add_option( FEATURE JPG
    DESCRIPTION "Support for JPG decoding/encoding"
    DEFAULT ON )
# Options related to JPG. The JasPer and OpenJPEG libraries
ecbuild_add_option( FEATURE JPG_LIBJASPER
    DESCRIPTION "Support for JPG decoding/encoding with the JasPer library"
    CONDITION ENABLE_JPG
    DEFAULT ON )
ecbuild_add_option( FEATURE JPG_LIBOPENJPEG
    DESCRIPTION "Support for JPG decoding/encoding with the OpenJPEG library"
    CONDITION ENABLE_JPG
    DEFAULT ON )

ecbuild_add_option( FEATURE PNG
    DESCRIPTION "Support for PNG decoding/encoding"
    DEFAULT OFF
    REQUIRED_PACKAGES PNG )

if( HAVE_PNG )
    set( HAVE_LIBPNG 1 ) # compatibility with autotools
    add_definitions( ${PNG_DEFINITIONS} )
else()
    set( HAVE_LIBPNG 0 )
endif()

ecbuild_add_option( FEATURE NETCDF
    DESCRIPTION "Support for GRIB to NetCDF conversion"
    DEFAULT ON
    REQUIRED_PACKAGES NetCDF
    NO_TPL )

find_package( AEC )
if(NOT DEFINED ENABLE_AEC AND NOT AEC_FOUND)
  ecbuild_critical("AEC library was not found.\n"
                   "AEC (Adaptive Entropy Coding) provides the WMO GRIB CCSDS compression and decompression of data. "
                   "This is highly recommended from ecCodes >= 2.25.0"
                   "\nTo force the build without it, use -DENABLE_AEC=OFF")
endif()
ecbuild_add_option( FEATURE AEC
    DESCRIPTION "Support for Adaptive Entropy Coding"
    DEFAULT ON
    CONDITION AEC_FOUND )

ecbuild_find_python( VERSION 3.6 NO_LIBS )
# find_package( NumPy )

## TODO REQUIRED_LANGUAGES Fortran
ecbuild_add_option( FEATURE FORTRAN
    DESCRIPTION "Build the ecCodes Fortran interface"
    DEFAULT ON )

# TODO Remove this after REQUIRED_LANGUAGES
if( ENABLE_FORTRAN )
    # will set EC_HAVE_FORTRAN with the result
    set( EC_HAVE_FORTRAN 0 )
    ecbuild_enable_fortran( MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/fortran/modules )
    set( HAVE_FORTRAN ${EC_HAVE_FORTRAN} )
else()
    set( HAVE_FORTRAN 0 )
endif()

# memfs requires only Python executable and not its libraries
ecbuild_add_option( FEATURE MEMFS
    DESCRIPTION "Memory based access to definitions/samples"
    DEFAULT OFF
    REQUIRED_PACKAGES Python3 )

#if( HAVE_MEMFS AND "${CMAKE_C_COMPILER_ID}" STREQUAL "Cray")
#  set( HAVE_MEMFS OFF )
#  ecbuild_warn("MEMFS not supported with Cray C compiler")
#endif()

if(HAVE_MEMFS)
  set( _will_install_defs_samples OFF )
else()
  set( _will_install_defs_samples ON )
endif()


# controls installation of files in definitions/ -- note that it still creates the symlinks in the build dir
# by default, if memfs is available, then we don't need to install definitions
ecbuild_add_option( FEATURE INSTALL_ECCODES_DEFINITIONS
    DESCRIPTION "Install the ecCodes definitions"
    DEFAULT ${_will_install_defs_samples} )

# controls installation of files in samples/ and ifs_samples/ -- note that it still creates the symlinks in the build dir
# by default, if memfs is available, then we don't need to install samples
ecbuild_add_option( FEATURE INSTALL_ECCODES_SAMPLES
    DESCRIPTION "Install the ecCodes samples, including IFS samples"
    DEFAULT ${_will_install_defs_samples} )

# advanced options (not visible in cmake-gui )

ecbuild_add_option( FEATURE MEMORY_MANAGEMENT   DESCRIPTION "Enable memory management" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ALIGN_MEMORY        DESCRIPTION "Enable memory alignment"  DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE TIMER               DESCRIPTION "Enable timer" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ECCODES_THREADS     DESCRIPTION "Enable POSIX threads" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ECCODES_OMP_THREADS DESCRIPTION "Enable OpenMP threads" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE EXTRA_TESTS         DESCRIPTION "Enable extended regression testing" DEFAULT OFF ADVANCED )

###############################################################################
# macro processing

set( ECCODES_EXTRA_LIBRARIES    "" )
set( ECCODES_EXTRA_INCLUDE_DIRS "" )
set( ECCODES_EXTRA_DEFINITIONS  "" )

find_package( CMath )
list( APPEND ECCODES_TPLS CMath )

### JPG support

set( HAVE_JPEG 0 )
set( HAVE_LIBJASPER 0 )
set( HAVE_LIBOPENJPEG 0 )

if( ENABLE_JPG )
    # Note: The function ecbuild_add_extra_search_paths is deprecated but we need it to find JasPer at ECMWF.
    #       It modifies CMAKE_PREFIX_PATH
    #       which can affect future package discovery if not undone by the caller.
    #       The current CMAKE_PREFIX_PATH is backed up as _CMAKE_PREFIX_PATH
    #
    #set(CMAKE_WARN_DEPRECATED OFF) # Suppress deprecation message
    #ecbuild_add_extra_search_paths( jasper )
    find_package( Jasper )
    #set(CMAKE_PREFIX_PATH ${_CMAKE_PREFIX_PATH})    # Restore CMAKE_PREFIX_PATH
    #set(CMAKE_WARN_DEPRECATED ON)  # Remove suppression

    find_package( OpenJPEG )

    if( JASPER_FOUND AND ENABLE_JPG_LIBJASPER )
        list( APPEND ECCODES_TPLS Jasper )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBJASPER 1 )
        # Extract JasPer's major version number to enable conditional code. See ECC-396
        string(REGEX REPLACE "^([0-9]+)\\.[0-9]+\\.[0-9]+.*" "\\1" JASPER_VERSION_MAJOR "${JASPER_VERSION_STRING}")
    endif()

    if( OPENJPEG_FOUND AND ENABLE_JPG_LIBOPENJPEG )
        list( APPEND ECCODES_TPLS OpenJPEG )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBOPENJPEG 1 )
    endif()

    ecbuild_info(" HAVE_JPEG=${HAVE_JPEG}")
    ecbuild_info(" HAVE_LIBJASPER=${HAVE_LIBJASPER}")
    ecbuild_info(" HAVE_LIBOPENJPEG=${HAVE_LIBOPENJPEG}")

endif()


###############################################################################
# other options

if( HAVE_TIMER )
    set( ECCODES_TIMER 1 )
else()
    set( ECCODES_TIMER 0 )
endif()

set( IS_BIG_ENDIAN 0 )
if( ECCODES_BIG_ENDIAN )
    set( IS_BIG_ENDIAN 1 )
endif()

set( MANAGE_MEM 0 )
if( ENABLE_MEMORY_MANAGEMENT )
    set( MANAGE_MEM 1 )
endif()

set( CMAKE_THREAD_PREFER_PTHREAD 1 ) # find thread library, but prefer pthreads
find_package(Threads REQUIRED)

# debug
ecbuild_info(" CMAKE_THREAD_LIBS_INIT=${CMAKE_THREAD_LIBS_INIT}")
ecbuild_info(" CMAKE_USE_PTHREADS_INIT=${CMAKE_USE_PTHREADS_INIT}")
ecbuild_info(" HAVE_ECCODES_THREADS=${HAVE_ECCODES_THREADS}")


set( GRIB_PTHREADS 0 )
set( GRIB_OMP_THREADS 0 )
set( GRIB_LINUX_PTHREADS 0 )
#if( HAVE_ECCODES_THREADS AND CMAKE_THREAD_LIBS_INIT )
if( HAVE_ECCODES_THREADS )
    if( NOT ${CMAKE_USE_PTHREADS_INIT} )
        ecbuild_critical("Pthreads is not supported on your system: thread library found=[${CMAKE_THREAD_LIBS_INIT}]")
    endif()
    set( GRIB_PTHREADS 1 )
    set( ECCODES_PTHREADS_LIBRARIES Threads::Threads ) # ECC-1268
    if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
        set( GRIB_LINUX_PTHREADS 1 )
    endif()
elseif(HAVE_ECCODES_OMP_THREADS)
    ecbuild_enable_omp()
    set( GRIB_OMP_THREADS 1 )
endif()

# Cannot have both options
if( HAVE_ECCODES_THREADS AND HAVE_ECCODES_OMP_THREADS )
    ecbuild_critical("Cannot enable both POSIX threads and OpenMP! Please specify just one option")
endif()

ecbuild_info(" POSIX THREADS = ${GRIB_PTHREADS}")
ecbuild_info(" OpenMP THREADS= ${GRIB_OMP_THREADS}")

set( GRIB_MEM_ALIGN 0 )
if( ENABLE_ALIGN_MEMORY )
  set( GRIB_MEM_ALIGN 1 )
endif()

# fix for #if IEEE_LE or IEE_BE instead of #ifdef

if( IEEE_BE )
    set( IEEE_LE 0 )
endif()

if( IEEE_LE )
    set( IEEE_BE 0 )
endif()

set( ECCODES_ON_WINDOWS 0 )
if( EC_OS_NAME MATCHES "windows" )
    # Symbols need to be explicitly exported on Windows so we can link to dlls.
    set( CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE )
    set( ECCODES_ON_WINDOWS 1 )

    # Suppress compliler warnings - see ECC-850
    # Suppress warnings about using 'insecure' functions. Fixing this would require changes all over
    # the codebase which would damage portability.
    ecbuild_add_c_flags("/D_CRT_SECURE_NO_WARNINGS")
    # Suppress warnings about using well-known C functions.

=== fortran/CMakeLists.txt ===
if( HAVE_FORTRAN )

    configure_file( eccodes_settings.h.in  eccodes_settings.h  @ONLY )

    set( srcdir ${CMAKE_CURRENT_SOURCE_DIR} )
    set( bindir ${CMAKE_CURRENT_BINARY_DIR} )

    include_directories( ${srcdir} ${bindir} )

    ecbuild_add_executable( TARGET  grib_types
                            NOINSTALL
                            SOURCES grib_types.f90 grib_fortran_kinds.c )

    add_custom_command( OUTPUT  grib_kinds.h
                        COMMAND grib_types > grib_kinds.h
                        DEPENDS grib_types )

    if( ${ECCODES_SIZEOF_INT} EQUAL ${ECCODES_SIZEOF_LONG} )
        set( _long_int_interface    grib_f90_int.f90 )
        set( _long_int_interface_ec eccodes_f90_int.f90 )
    else()
        set( _long_int_interface    grib_f90_long_int.f90 )
        set( _long_int_interface_ec eccodes_f90_long_int.f90 )
    endif()

    if( ${ECCODES_SIZEOF_INT} EQUAL ${ECCODES_SIZEOF_SIZE_T} )
        set( _sizet_int_interface    grib_f90_int_size_t.f90 )
        set( _sizet_int_interface_ec eccodes_f90_int_size_t.f90 )
    else()
        set( _sizet_int_interface    grib_f90_long_size_t.f90 )
        set( _sizet_int_interface_ec eccodes_f90_long_size_t.f90 )
    endif()

    add_custom_command( OUTPUT  grib_f90.f90
                        COMMAND cat ${srcdir}/grib_f90_head.f90 ${srcdir}/${_long_int_interface} ${srcdir}/${_sizet_int_interface} ${srcdir}/grib_f90_tail.f90 > grib_f90.f90
                        DEPENDS grib_f90_head.f90 grib_f90_tail.f90 grib_kinds.h ${_long_int_interface} ${_sizet_int_interface} )
    add_custom_command( OUTPUT  eccodes_f90.f90
                        COMMAND cat ${srcdir}/eccodes_f90_head.f90 ${srcdir}/${_long_int_interface_ec} ${srcdir}/${_sizet_int_interface_ec} ${srcdir}/eccodes_f90_tail.f90 > eccodes_f90.f90
                        DEPENDS eccodes_f90_head.f90 eccodes_f90_tail.f90 grib_kinds.h ${_long_int_interface_ec} ${_sizet_int_interface_ec} )


    # Note: $<BUILD_INTERFACE:...> will be present only while building (for the whole bundle),
    # whereas $<INSTALL_INTERFACE:...> is only present once you install the package / bundle
    ecbuild_add_library( TARGET          eccodes_f90
                         SOURCES         grib_fortran.c grib_f90.f90 eccodes_f90.f90 grib_kinds.h
                         GENERATED       grib_f90.f90 eccodes_f90.f90
                         PUBLIC_INCLUDES $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>
                                         $<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}>
                         PRIVATE_LIBS    eccodes ${ECCODES_PTHREADS_LIBRARIES} )

    if( DEFINED ecbuild_VERSION AND NOT ${ecbuild_VERSION} VERSION_LESS 3.1 )
        # Installed module directory is not in the PUBLIC INCLUDES!
        target_include_directories( eccodes_f90 PUBLIC $<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}> )

        # NOTE: When eccodes accepts ecbuild 3.0 as minimum requirement,
        # this should instead be written inside the ecbuild_add_library macro with:
        #    PUBLIC_INCLUDES $<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}>
    endif()

    add_custom_command( TARGET     eccodes_f90 POST_BUILD
                        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/include
                        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/eccodes.mod ${CMAKE_BINARY_DIR}/include
                        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/grib_api.mod ${CMAKE_BINARY_DIR}/include )

    # Add the eccodes module file as well
    #set(_eccodes_mod "${CMAKE_Fortran_MODULE_DIRECTORY}/eccodes.mod" )

    #add_custom_command(
    #    OUTPUT ${_eccodes_mod}
    #    WORKING_DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}
    #    #COMMAND ${CMAKE_COMMAND} -E create_symlink "${CMAKE_Fortran_MODULE_DIRECTORY}/grib_api.mod" ${_eccodes_mod}
    #    #COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_Fortran_MODULE_DIRECTORY}/grib_api.mod" ${_eccodes_mod}
    #    COMMAND "/usr/bin/sh" "-c" "if test -f GRIB_API.mod; then ln -s GRIB_API.mod ECCODES.mod; fi"
    #    COMMAND "/usr/bin/sh" "-c" "if test -f grib_api.mod; then ln -s grib_api.mod eccodes.mod; fi"
    #   DEPENDS eccodes_f90
    #    VERBATIM
    #)
    #add_custom_target(add_eccodes_mod ALL DEPENDS ${_eccodes_mod})

    ecbuild_add_resources( TARGET fortran_resources
                           PACK
                            grib_api_constants.h grib_api_externals.h
                            grib_api_visibility.h grib_types.f90 create_grib_f90.sh
                            grib_f90.f90.head grib_f90.f90.tail grib_f90_int.f90 grib_f90_long_int.f90
                            grib_f90_int_size_t.f90 grib_f90_long_size_t.f90

                            eccodes_visibility.h eccodes_constants.h
                            eccodes_f90.f90.head eccodes_f90.f90.tail eccodes_f90_int.f90 eccodes_f90_long_int.f90
                            eccodes_f90_int_size_t.f90 eccodes_f90_long_size_t.f90

                            same_int_long.f90 same_int_size_t.f90 grib_fortran_kinds.c )



### installation

    # Install the generated .mod file
    # install( CODE "EXECUTE_PROCESS (COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR} ${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR})" )

    # Install the contents of the fortran module directory
    if(ECBUILD_INSTALL_FORTRAN_MODULES)
        install( DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/  DESTINATION ${INSTALL_INCLUDE_DIR} )
    endif()

    # Install the eccodes module file as a copy of the grib api mod file.
    # Note: the mod filename can be lowercase or uppercase!
    # First try the lowercase one. Specify OPTIONAL so if it fails it carries on
    #install( FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/grib_api.mod
    #                 RENAME eccodes.mod
    #                 OPTIONAL
    #                 DESTINATION ${INSTALL_INCLUDE_DIR} )
    # Now try the uppercase mod file
    #install( FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/GRIB_API.mod
    #                 RENAME ECCODES.mod
    #                 OPTIONAL
    #                 DESTINATION ${INSTALL_INCLUDE_DIR} )

endif()

=== src/CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#
list( APPEND eccodes_src_files
    step_unit.cc
    step.cc
    step_utilities.cc
    grib_api.h
    grib_timer.cc
    eccodes.h
    action.cc
    action_class_alias.cc
    action_class_gen.cc
    action_class_if.cc
    action_class_switch.cc
    grib_accessor_class_g1fcperiod.cc
    grib_accessor_class_g1end_of_interval_monthly.cc
    grib_accessor_class_mars_param.cc
    action_class_section.cc
    action_class_list.cc
    action_class_while.cc
    action_class_put.cc
    action_class_meta.cc
    action_class_remove.cc
    action_class_rename.cc
    action_class_assert.cc
    action_class_template.cc
    action_class_trigger.cc
    action_class_when.cc
    action_class_concept.cc
    action_class_hash_array.cc
    action_class_set.cc
    action_class_set_sarray.cc
    action_class_set_darray.cc
    action_class_noop.cc
    action_class_write.cc
    action_class_print.cc
    action_class_close.cc
    action_class_variable.cc
    action_class_modify.cc
    action_class_transient_darray.cc
    eccodes.cc
    grib_accessor.cc
    grib_concept.cc
    grib_hash_array.cc
    grib_bufr_descriptor.cc
    grib_bufr_descriptors_array.cc
    grib_darray.cc
    grib_sarray.cc
    grib_oarray.cc
    grib_vdarray.cc
    grib_vsarray.cc
    grib_iarray.cc
    grib_viarray.cc
    codes_memfs.cc
    grib_accessor_class_ascii.cc
    grib_accessor_class_bit.cc
    grib_accessor_class_bitmap.cc
    grib_accessor_class_bits.cc
    grib_accessor_class_bits_per_value.cc
    grib_accessor_class_bufr_elements_table.cc
    grib_accessor_class_bufr_data_array.cc
    grib_accessor_class_bufr_data_element.cc
    grib_accessor_class_bufr_group.cc
    grib_accessor_class_bufr_string_values.cc
    grib_accessor_class_pack_bufr_values.cc
    grib_accessor_class_unpack_bufr_values.cc
    grib_accessor_class_group.cc
    grib_accessor_class_non_alpha.cc
    grib_accessor_class_g1bitmap.cc
    grib_accessor_class_g2bitmap.cc
    grib_accessor_class_concept.cc
    grib_accessor_class_hash_array.cc
    grib_accessor_class_decimal_precision.cc
    grib_accessor_class_divdouble.cc
    grib_accessor_class_budgdate.cc
    grib_accessor_class_validity_date.cc
    grib_accessor_class_validity_time.cc
    grib_accessor_class_bytes.cc
    grib_accessor_class.cc
    grib_accessor_class_change_alternative_row_scanning.cc
    grib_accessor_class_change_scanning_direction.cc
    grib_accessor_class_check_internal_version.cc
    grib_accessor_class_codeflag.cc
    grib_accessor_class_smart_table.cc
    grib_accessor_class_smart_table_column.cc
    grib_accessor_class_codetable.cc
    grib_accessor_class_codetable_units.cc
    grib_accessor_class_codetable_title.cc
    grib_accessor_class_step_human_readable.cc
    grib_accessor_class_count_file.cc
    grib_accessor_class_count_total.cc
    grib_accessor_class_double.cc
    grib_accessor_class_element.cc
    grib_accessor_class_evaluate.cc
    grib_accessor_class_g1date.cc
    grib_accessor_class_g1monthlydate.cc
    grib_accessor_class_library_version.cc
    grib_accessor_class_when.cc
    grib_accessor_class_g1verificationdate.cc
    grib_accessor_class_g1day_of_the_year_date.cc
    grib_accessor_class_g1_half_byte_codeflag.cc
    grib_accessor_class_g1forecastmonth.cc
    grib_accessor_class_g1step_range.cc
    grib_accessor_class_g2step_range.cc
    grib_accessor_class_data_g22order_packing.cc
    grib_accessor_class_mars_step.cc
    grib_accessor_class_message_copy.cc
    grib_accessor_class_dictionary.cc
    grib_accessor_class_latlon_increment.cc
    grib_accessor_class_g2date.cc
    grib_accessor_class_g2level.cc
    grib_accessor_class_g2end_step.cc
    grib_accessor_class_g2latlon.cc
    grib_accessor_class_g2lon.cc
    grib_accessor_class_global_gaussian.cc
    grib_accessor_class_gaussian_grid_name.cc
    grib_accessor_class_gen.cc
    grib_accessor_class_getenv.cc
    grib_accessor_class_gts_header.cc
    grib_accessor_class_ifs_param.cc
    grib_accessor_class_julian_day.cc
    grib_accessor_class_julian_date.cc
    grib_accessor_class_closest_date.cc
    grib_accessor_class_latlonvalues.cc
    grib_accessor_class_latitudes.cc
    grib_accessor_class_longitudes.cc
    grib_accessor_class_offset_file.cc
    grib_accessor_class_scale.cc
    grib_accessor_class_from_scale_factor_scaled_value.cc
    grib_accessor_class_g2bitmap_present.cc
    grib_accessor_class_ibmfloat.cc
    grib_accessor_class_ieeefloat.cc
    grib_accessor_class_constant.cc
    grib_accessor_class_iterator.cc
    grib_accessor_class_message.cc
    grib_accessor_class_nearest.cc
    grib_accessor_class_ksec1expver.cc
    grib_accessor_class_label.cc
    grib_accessor_class_long.cc
    grib_accessor_class_lookup.cc
    grib_accessor_class_octahedral_gaussian.cc
    grib_accessor_class_octet_number.cc
    grib_accessor_class_headers_only.cc
    grib_accessor_class_padding.cc
    grib_accessor_class_pad.cc
    grib_accessor_class_padto.cc
    grib_accessor_class_padtoeven.cc
    grib_accessor_class_padtomultiple.cc
    grib_accessor_class_section_padding.cc
    grib_accessor_class_packing_type.cc
    grib_accessor_class_section_pointer.cc
    grib_accessor_class_position.cc
    grib_accessor_class_signed.cc
    grib_accessor_class_signed_bits.cc
    grib_accessor_class_section.cc
    grib_accessor_class_step_in_units.cc
    grib_accessor_class_optimal_step_units.cc
    grib_accessor_class_section_length.cc
    grib_accessor_class_g1_message_length.cc
    grib_accessor_class_g1_section4_length.cc
    grib_accessor_class_size.cc
    grib_accessor_class_rdbtime_guess_date.cc
    grib_accessor_class_scale_values.cc
    grib_accessor_class_offset_values.cc
    grib_accessor_class_sprintf.cc
    grib_accessor_class_round.cc
    grib_accessor_class_spectral_truncation.cc
    grib_accessor_class_time.cc
    grib_accessor_class_transient.cc
    grib_accessor_class_trim.cc
    grib_accessor_class_transient_darray.cc
    grib_accessor_class_values.cc
    grib_accessor_class_simple_packing_error.cc
    grib_accessor_class_data_simple_packing.cc
    grib_accessor_class_count_missing.cc
    grib_accessor_class_data_sh_packed.cc
    grib_accessor_class_data_sh_unpacked.cc
    grib_accessor_class_number_of_values_data_raw_packing.cc
    grib_accessor_class_data_g1simple_packing.cc
    grib_accessor_class_data_g1shsimple_packing.cc
    grib_accessor_class_data_shsimple_packing.cc
    grib_accessor_class_data_dummy_field.cc
    grib_accessor_class_variable.cc
    grib_accessor_class_second_order_bits_per_value.cc
    grib_accessor_class_data_g2simple_packing.cc
    grib_accessor_class_data_g2simple_packing_with_preprocessing.cc
    grib_accessor_class_data_g2shsimple_packing.cc
    grib_accessor_class_data_g2complex_packing.cc
    grib_accessor_class_data_g1second_order_row_by_row_packing.cc
    grib_accessor_class_data_g1second_order_constant_width_packing.cc
    grib_accessor_class_data_g1second_order_general_packing.cc
    grib_accessor_class_data_g1second_order_general_extended_packing.cc
    grib_accessor_class_g2grid.cc
    grib_accessor_class_unexpanded_descriptors.cc
    grib_accessor_class_expanded_descriptors.cc
    grib_accessor_class_bufrdc_expanded_descriptors.cc
    grib_accessor_class_data_apply_bitmap.cc
    grib_accessor_class_data_apply_boustrophedonic.cc
    grib_accessor_class_data_apply_boustrophedonic_bitmap.cc
    grib_accessor_class_data_secondary_bitmap.cc
    grib_accessor_class_data_g1secondary_bitmap.cc
    grib_accessor_class_data_g2secondary_bitmap.cc
    grib_accessor_class_data_jpeg2000_packing.cc
    grib_accessor_class_data_png_packing.cc
    grib_accessor_class_data_ccsds_packing.cc
    grib_accessor_class_data_raw_packing.cc
    grib_accessor_class_data_complex_packing.cc
    grib_accessor_class_data_g1complex_packing.cc
    grib_accessor_class_gds_not_present_bitmap.cc
    grib_accessor_class_gds_is_present.cc
    grib_accessor_class_select_step_template.cc
    grib_accessor_class_local_definition.cc
    grib_accessor_class_g2_eps.cc
    grib_accessor_class_g2_aerosol.cc
    grib_accessor_class_g2_chemical.cc
    grib_accessor_class_g2_mars_labeling.cc
    grib_accessor_class_md5.cc
    grib_accessor_class_proj_string.cc
    grib_jasper_encoding.cc
    grib_openjpeg_encoding.cc
    action_class_set_missing.cc
    grib_accessor_class_number_of_points.cc
    grib_accessor_class_suppressed.cc
    grib_index.cc
    grib_accessor_class_number_of_points_gaussian.cc
    grib_accessor_class_number_of_values.cc
    grib_accessor_class_number_of_coded_values.cc
    grib_accessor_class_g1number_of_coded_values_sh_complex.cc
    grib_accessor_class_g1number_of_coded_values_sh_simple.cc
    grib_accessor_class_dirty.cc
    grib_accessor_class_statistics.cc
    grib_accessor_class_statistics_spectral.cc
    grib_accessor_class_unsigned.cc
    grib_accessor_class_unsigned_bits.cc
    grib_accessor_class_raw.cc
    grib_accessor_class_bufr_simple_thinning.cc
    grib_accessor_class_bufr_extract_subsets.cc
    grib_accessor_class_bufr_extract_area_subsets.cc
    grib_accessor_class_bufr_extract_datetime_subsets.cc
    grib_accessor_class_spd.cc
    grib_accessor_class_sum.cc
    grib_accessor_class_to_integer.cc
    grib_accessor_class_to_double.cc
    grib_accessor_class_to_string.cc
    grib_accessor_class_sexagesimal2decimal.cc
    grib_accessor_class_vector.cc
    grib_accessor_class_long_vector.cc
    grib_gaussian_reduced.cc
    grib_accessor_class_abstract_vector.cc
    grib_accessor_class_abstract_long_vector.cc
    grib_loader_from_handle.cc
    grib_bits.cc
    grib_ibmfloat.cc
    grib_ieeefloat.cc
    grib_accessor_class_reference_value_error.cc
    grib_memory.cc
    grib_buffer.cc
    grib_dumper.cc
    grib_dumper_class_serialize.cc
    grib_dumper_class_debug.cc
    grib_dumper_class_default.cc
    grib_dumper_class_bufr_encode_C.cc
    grib_dumper_class_bufr_encode_filter.cc
    grib_dumper_class_bufr_encode_fortran.cc
    grib_dumper_class_bufr_encode_python.cc
    grib_dumper_class_bufr_decode_C.cc
    grib_dumper_class_bufr_decode_filter.cc
    grib_dumper_class_bufr_decode_fortran.cc
    grib_dumper_class_bufr_decode_python.cc
    grib_dumper_class_bufr_simple.cc
    grib_dumper_class_json.cc
    grib_dumper_class_grib_encode_C.cc
    grib_dumper_class_wmo.cc
    grib_dumper_class.cc
    grib_context.cc
    grib_date.cc
    grib_fieldset.cc
    grib_filepool.cc
    grib_geography.cc
    grib_handle.cc
    grib_hash_keys.cc
    grib_io.cc
    grib_trie.cc
    grib_trie_with_rank.cc
    grib_itrie.cc
    grib_rules.cc
    grib_keys_iterator.cc
    bufr_keys_iterator.cc
    grib_parse_utils.cc
    grib_query.cc
    grib_scaling.cc
    grib_templates.cc
    grib_dependency.cc
    grib_value.cc
    grib_errors.cc
    grib_expression_class_binop.cc
    grib_expression_class_logical_and.cc
    grib_expression_class_logical_or.cc
    grib_expression_class_is_in_dict.cc
    grib_expression_class_true.cc
    grib_expression_class_string_compare.cc
    grib_expression_class_unop.cc
    grib_expression_class_functor.cc
    grib_expression_class_accessor.cc
    grib_expression_class_is_in_list.cc
    grib_expression_class_is_integer.cc
    grib_expression_class_length.cc
    grib_expression_class_long.cc
    grib_expression_class_double.cc
    grib_expression_class_string.cc
    grib_expression_class_sub_string.cc
    grib_nearest.cc
    grib_nearest_class.cc
    grib_nearest_class_gen.cc
    grib_nearest_class_healpix.cc
    grib_nearest_class_regular.cc
    grib_nearest_class_reduced.cc
    grib_nearest_class_latlon_reduced.cc
    grib_nearest_class_lambert_conformal.cc

=== tests/CMakeLists.txt ===
# tests/CMakeLists.txt
#
# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/utils.sh   ${CMAKE_CURRENT_BINARY_DIR} )
execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/number_compare.pl ${CMAKE_CURRENT_BINARY_DIR} )

# Build the executables used by test scripts
################################################
list(APPEND test_c_bins
    list_codetable_flagtable_keys
    wmo_read_bufr_from_file
    wmo_read_gts_from_file
    wmo_read_any_from_file
    wmo_read_any_from_stream
    grib_bpv_limit
    grib_double_cmp
    read_any
    julian
    grib_indexing
    grib_fieldset
    grib_multi_from_message
    grib_clone_headers_only
    grib_read_index
    grib_set_large_message_fail
    unit_tests
    bufr_keys_iter
    grib_keys_iter
    grib_keys_iter_skip
    grib_geo_iter
    gauss_sub
    grib_nearest_test
    grib_util_set_spec
    grib_check_param_concepts
    grib_local_MeteoFrance
    grib_2nd_order_numValues
    grib_optimize_scaling
    grib_optimize_scaling_sh
    grib_set_force
    grib_run_length_packing
    grib_partial_message
    grib_ecc-386
    grib_ecc-1467
    grib_ecc-1431
    grib_ecc-1433
    bufr_ecc-517
    bufr_ecc-1288
    bufr_get_element
    bufr_extract_headers
    bufr_check_descriptors
    bufr_coordinate_descriptors
    codes_new_from_samples
    codes_dump_action_tree
    codes_set_samples_path
    codes_compare_keys
    codes_dump_content
    codes_codetable
    codes_get_string
    grib_sh_ieee64
    grib_ieee
    grib_set_bytes
    grib_copy_message
    grib_packing_order
    grib_unpack_subarray
    grib_sh_imag
    grib_spectral
    grib_lam_bf
    grib_lam_gp)


foreach( tool ${test_c_bins} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET    ${tool}
                            NOINSTALL
                            SOURCES   ${tool}.cc
                            LIBS      eccodes )
endforeach()


# Now add each test (shell scripts)
#################################################
if( HAVE_BUILD_TOOLS )

    # These tests do not require any data downloads
    # and are generally quick
    list(APPEND tests_basic
        codes_info
        codes_deprecated
        unit_tests
        julian
        grib_dump_samples
        bufr_dump_samples
        bufr_check_descriptors
        definitions
        grib2_version
        grib_accessors
        grib_calendar
        grib_md5
        grib_cfNames
        grib_ifsParam
        grib_packing_order
        filter_substr
        filter_is_in_list
        filter_transient_darray
        grib_uerra
        grib_ecpoint
        grib_s2s
        grib_fire
        grib_generalised_tiles
        # grib_true_imagery
        grib2_wave_spectra
        grib_element
        grib_suppressed
        grib_2nd_order_numValues
        grib_ecc-136
        grib_ecc-530
        grib_ecc-922
        grib_ecc-966
        grib_ecc-967
        grib_ecc-1150
        grib_ecc-1053
        grib_ecc-1065
        grib_ecc-1167
        grib_ecc-1170
        grib_ecc-1195
        grib_ecc-1212
        grib_ecc-1230
        grib_ecc-1258
        grib_ecc-1260
        grib_ecc-1261
        grib_ecc-1271
        grib_ecc-1315
        grib_ecc-1322
        grib_ecc-1319
        grib_ecc-1406
        grib_ecc-1440
        grib_ecc-1560
        grib_ecc-1571
        grib_ecc-1654
        grib_ecc-1671
        grib_ecc-1708
        grib_ecc-1691
        bufr_ecc-1028
        bufr_ecc-1195
        bufr_ecc-1259
        bufr_ecc-1290
        bufr_ecc-1304
        bufr_ecc-1347
        bufr_ecc-1395
        bufr_json_samples
        bufr_ecc-359
        bufr_ecc-517
        grib_efas
        grib_sh_imag
        grib_spectral
        grib_levtype
        grib_typeOfLevel
        grib_grid_unstructured
        grib_grid_lambert_conformal
        grib_grid_polar_stereographic
        grib_grid_healpix
        grib_g1day_of_the_year_date
    )

    # These tests require data downloads
    # and/or take much longer
    list(APPEND tests_extra
        grib_data_quality_checks
        grib_set_large_message_fail
        grib_g1monthlydate
        grib_g1fcperiod
        grib_bpv_limit
        grib_complex
        grib_double_cmp
        grib_change_packing
        grib_run_length_packing
        grib_grid_space_view
        grib_partial_message
        grib_true_imagery
        grib_headers_only
        grib_unpack_subarray
        grib_count
        grib_clone_headers_only
        wmo_read_bufr_from_file
        wmo_read_gts_from_file
        wmo_read_any_from_file
        wmo_read_any_from_stream
        bufr_templates
        bufr_rdbSubTypes
        bufr_dump_data
        bufr_dump_descriptors
        bufr_coordinate_descriptors
        bufr_dump_subset
        bufr_dump_decode_filter
        bufr_dump_encode_filter
        bufrdc_desc_ref
        bufrdc_ref
        bufr_compare
        bufr_copy
        bufr_count
        bufr_get
        bufr_operators
        bufr_filter_misc
        bufr_filter_fail
        bufr_filter_extract_subsets
        bufr_filter_extract_datetime
        bufr_filter_extract_area
        bufr_filter_unpack_pack
        bufr_filter_skipExtraKeyAttributes
        bufr_indexing
        bufr_json_data
        bufr_ls
        bufr_ls_json
        bufr_change_edition
        bufr_keys_iter
        grib_keys_iter
        grib_keys_iter_skip
        grib_geo_iter
        bufr_get_element
        bufr_wmo_tables
        bufr_extract_headers
        extract_offsets
        bufr_ecc-147
        bufr_ecc-389
        bufr_ecc-673
        bufr_ecc-428
        bufr_ecc-286
        bufr_ecc-288
        bufr_ecc-313
        bufr_ecc-616
        bufr_ecc-680
        bufr_ecc-686
        bufr_ecc-690
        bufr_ecc-379
        bufr_ecc-393
        bufr_ecc-433
        bufr_ecc-750
        bufr_ecc-765
        bufr_ecc-875
        bufr_ecc-887
        bufr_ecc-1187
        bufr_ecc-1305
        bufr_ecc-1476
        bufr_ecc-1623
        grib_ecc-490
        grib_ecc-756
        grib_ecc-806
        grib_ecc-873
        grib_ecc-600
        grib_ecc-923
        grib_ecc-979
        grib_ecc-984
        grib_ecc-1000
        grib_ecc-1001
        grib_ecc-1030
        grib_ecc-1364
        grib_ecc-1397
        grib_ecc-1425
        grib_ecc-1467
        grib_sub_hourly
        grib_set_bytes
        grib_set_force
        bufr_ecc-556
        codes_ecc-1698
        codes_get_string
        codes_codetable
        gts_get
        gts_ls
        gts_count
        gts_compare
        gts_dump
        wrap
        hdf5
        taf
        pseudo_diag
        metar_ls
        metar_filter
        metar_get
        metar_dump
        metar_compare
        bufr_set
        grib_ieee
        grib1_gds_not_present
        grib_sh_ieee64
        grib_optimize_scaling
        grib_optimize_scaling_sh
        grib_lam_bf
        grib_lam_gp
        grib1to2
        grib2to1
        grib1to3
        grib2to3
        grib2_templates
        grib2_chemicals_aerosols
        grib3_templates
        grib_bad
        grib_ls
        grib_ls_json
        grib_filter
        grib_multi
        grib_nearest_test
        pseudo_budg
        grib_gridType
        grib_fieldset
        grib_octahedral
        grib_grid_mercator
        grib_global
        grib_concept
        grib_copy_message
        grib_decimalPrecision
        grib_bitsPerValue
        grib_get_fail
        grib_missing
        grib_local
        grib_step
        grib_set
        grib_set_fail
        grib_iterator
        grib_proj_string
        grib_compare
        grib_copy
        grib_level
        grib_indexing
        grib_bitmap
        grib_secondary_bitmap
        grib_list
        grib_second_order
        grib_multi_from_message
        grib_change_scanning
        grib_statistics
        read_any
        codes_new_from_samples
        codes_dump_action_tree
        codes_set_samples_path
        codes_compare_keys
        codes_dump_content
        codes_to_double
        grib_dump
        grib_dump_debug
        grib_dump_json
        grib_local_MeteoFrance
        grib_local_NCEP
        grib_neg_fctime
        codes_split_file
        grib_mars_keys1
        grib_mars_keys2)

    if( HAVE_AEC AND ENABLE_EXTRA_TESTS )
        list(APPEND tests_extra grib_ecc-1431)
        list(APPEND tests_extra grib_ecc-1433)
    endif()
    if( HAVE_FORTRAN AND ENABLE_EXTRA_TESTS )
        list(APPEND tests_extra bufr_dump_encode_fortran)
        list(APPEND tests_extra bufr_dump_decode_fortran)
    endif()
    if( ENABLE_EXTRA_TESTS )
        list(APPEND tests_extra grib_util_set_spec)
        list(APPEND tests_extra grib_padding)
        list(APPEND tests_extra grib_tigge_conversions1)
        list(APPEND tests_extra grib_tigge_conversions2)
        list(APPEND tests_extra bufr_dump_encode_C)
        list(APPEND tests_extra bufr_dump_decode_C)
        list(APPEND tests_extra bufr_dump_encode_python)
        list(APPEND tests_extra bufr_dump_decode_python)
        list(APPEND tests_extra list_codetable_flagtable_keys)
    endif()

    # These tests do not require any data downloads
    foreach( test ${tests_basic} )
        ecbuild_add_test( TARGET  eccodes_t_${test}
                          TYPE    SCRIPT
                          LABELS  "sanity"
                          COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh )
    endforeach()
    ecbuild_add_test( TARGET eccodes_t_grib_check_gaussian_grids
                      TYPE SCRIPT
                      CONDITION ECCODES_INSTALL_EXTRA_TOOLS
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_check_gaussian_grids.sh )
    ecbuild_add_test( TARGET eccodes_t_grib_repair
                      TYPE SCRIPT
                      CONDITION ECCODES_INSTALL_EXTRA_TOOLS AND ENABLE_EXTRA_TESTS
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_repair.sh )


    # Note: making the test dependent on the grib files (with DEPENDS)
    #       means they will be downloaded at "make" time
    #       rather than when you do "ctest". Use TEST_DEPENDS instead
    foreach( test ${tests_extra} )
        ecbuild_add_test( TARGET eccodes_t_${test}
                      TYPE SCRIPT
                      CONDITION ENABLE_EXTRA_TESTS
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                      RESOURCES asca_139.t1.ref
                      TEST_DEPENDS eccodes_download_gribs eccodes_download_tigge_gribs
                                   eccodes_download_bufrs eccodes_download_bufr_refs
                                   eccodes_download_metars eccodes_download_gts )
    endforeach()

    if( HAVE_FORTRAN AND ENABLE_EXTRA_TESTS )
        set_tests_properties( eccodes_t_bufr_dump_encode_fortran PROPERTIES TIMEOUT 2500 )
    endif()
    if( ENABLE_EXTRA_TESTS )
        set_tests_properties( eccodes_t_bufr_dump_encode_C PROPERTIES TIMEOUT 2500 )
    endif()


    ###########################################
    # Note: the reference file is in the tests dir not data dir!
    ecbuild_add_test( TARGET eccodes_t_grib_grid_lamb_az_eq_area
                      TYPE SCRIPT
                      CONDITION ENABLE_EXTRA_TESTS
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_grid_lamb_az_eq_area.sh
                      RESOURCES grib_lamb_az_eq_area.ref
                      TEST_DEPENDS eccodes_download_gribs )

    # These ones are conditional
    ###########################################
    ecbuild_add_test( TARGET eccodes_t_tools_data_from_stdin
                      TYPE SCRIPT
                      CONDITION NOT ECCODES_ON_WINDOWS AND ENABLE_EXTRA_TESTS
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools_data_from_stdin.sh
                      TEST_DEPENDS eccodes_download_bufrs )

=== tools/CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

list( APPEND ecc_tools_sources
             grib_tools.cc
             grib_options.cc
             grib_tools.h )

if( EC_OS_NAME MATCHES "windows" )
  list( APPEND ecc_tools_sources wingetopt.cc )
endif()

# tools library
ecbuild_add_library( TARGET    ecc_tools
                     TYPE      STATIC
                     NOINSTALL
                     SOURCES   ${ecc_tools_sources}
                     PRIVATE_LIBS      eccodes )

# tools binaries
list( APPEND ecc_tools_binaries
             codes_info codes_count codes_split_file
             grib_histogram grib_filter grib_ls grib_dump grib_merge
             grib2ppm grib_set grib_get grib_get_data grib_copy
             grib_compare codes_parser grib_index_build bufr_index_build
             bufr_ls bufr_dump bufr_set bufr_get
             bufr_copy bufr_compare
             gts_get gts_compare gts_copy gts_dump gts_filter gts_ls
             metar_dump metar_ls metar_compare metar_get metar_filter metar_copy )

list( APPEND ecc_tools_binaries_extra
             big2gribex
             gg_sub_area_check
             grib_repair
             grib_to_json
             codes_export_resource
             grib_check_gaussian_grid
             bufr_split_by_rdbSubtype )

# Install generic tools
foreach( tool ${ecc_tools_binaries} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.cc
                            LIBS       ecc_tools )
endforeach()

# Install extra tools
# User must run cmake with -DECCODES_INSTALL_EXTRA_TOOLS=ON
foreach( tool ${ecc_tools_binaries_extra} )
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.cc
                            CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                            LIBS       ecc_tools )
endforeach()


# grib_count/bufr_count etc. Same source code, different executable names
ecbuild_add_executable( TARGET     grib_count
                        SOURCES    codes_count.cc
                        LIBS       ecc_tools )
ecbuild_add_executable( TARGET     bufr_count
                        SOURCES    codes_count.cc
                        LIBS       ecc_tools )
ecbuild_add_executable( TARGET     gts_count
                        SOURCES    codes_count.cc
                        LIBS       ecc_tools )

# grib to netcdf is optional
ecbuild_add_executable( TARGET     grib_to_netcdf
                        SOURCES    grib_to_netcdf.cc
                        CONDITION  HAVE_NETCDF
                        LIBS       ecc_tools NetCDF::NetCDF_C )


ecbuild_add_executable( TARGET     grib_list_keys
                        SOURCES    list_keys.cc
                        CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                        LIBS       ecc_tools )

ecbuild_add_executable( TARGET     codes_bufr_filter
                        SOURCES    bufr_filter.cc
                        LIBS       ecc_tools )


if( ECCODES_INSTALL_EXTRA_TOOLS )
    ecbuild_info("ECCODES_INSTALL_EXTRA_TOOLS enabled")
else()
    ecbuild_info("ECCODES_INSTALL_EXTRA_TOOLS disabled")
endif()
########################################

# BUFR compare script
install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_compare_dir
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )


# bufr_filter script (See ECC-205)
execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/tools/bufr_filter
    ${CMAKE_BINARY_DIR}/bin/ )

install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_filter
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )

=== examples/C/CMakeLists.txt ===
# examples/C/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )


# Build the executables used by test scripts
#############################################
list( APPEND test_bins
      grib_nearest
      grib_set_bitmap
      grib_iterator
      grib_get_keys
      grib_print_data
      grib_set_keys
      grib_index
      grib_set_missing
      grib_keys_iterator
      grib_set_data
      grib_nearest_multiple
      grib_multi
      grib_multi_write
      grib_precision
      grib_set_pv
      grib_list
      grib_get_data
      grib_sections_copy
      grib_copy_keys
      grib_iterator_bitmap
      grib_clone
      grib_copy_message
      grib_ensemble_index
      bufr_copy_data
      bufr_attributes
      bufr_clone
      bufr_expanded
      bufr_get_keys
      bufr_get_string_array
      bufr_keys_iterator
      bufr_missing
      bufr_read_header
      bufr_read_scatterometer
      bufr_read_synop
      bufr_read_temp
      bufr_read_tempf
      bufr_set_keys
      bufr_subset
      mars_param
      grib_values_check
      multi2
      large_grib1
      get_product_kind)

foreach( tool ${test_bins} )
    ecbuild_add_executable( TARGET    c_${tool}
                            NOINSTALL
                            SOURCES   ${tool}.c
                            LIBS      eccodes )
endforeach()

# Now add each test (shell scripts)
####################################
if( HAVE_BUILD_TOOLS )
    # Command line tools are available
    list(APPEND tests_sanity
         grib_set_data
         large_grib1
         grib_sections_copy
         grib_copy_keys
         get_product_kind_samples)
    list(APPEND tests_extra
       grib_iterator
       grib_get_keys
       grib_print_data
       grib_set_keys
       grib_keys_iterator
       grib_multi_write
       grib_precision
       grib_clone
       grib_copy_message
       grib_ensemble_index
       grib_index
       grib_set_pv
       grib_set_bitmap
       grib_list
       grib_get_data
       grib_mars_param
       grib_nearest
       grib_nearest_multiple
       grib_multi
       grib_set_missing
       grib_values_check
       bufr_attributes
       bufr_copy_data
       bufr_clone
       bufr_expanded
       bufr_get_keys
       bufr_get_string_array
       bufr_keys_iterator
       bufr_missing
       bufr_read_header
       bufr_read_scatterometer
       bufr_read_synop
       bufr_read_temp
       bufr_read_tempf
       bufr_set_keys
       bufr_subset
       get_product_kind)
else()
    # No command line tools
    list(APPEND tests_sanity
        grib_set_data
        get_product_kind_samples)
    list(APPEND tests_extra
       grib_iterator
       grib_get_keys
       grib_print_data
       grib_set_keys
       grib_keys_iterator
       grib_precision
       grib_ensemble_index
       grib_set_pv
       grib_list
       grib_get_data
       grib_nearest_multiple
       grib_multi
       grib_set_missing
       bufr_attributes
       bufr_expanded
       bufr_get_keys
       bufr_get_string_array
       bufr_keys_iterator
       bufr_missing
       bufr_read_header
       bufr_read_scatterometer
       bufr_read_synop
       bufr_read_temp
       bufr_read_tempf
       bufr_set_keys
       bufr_subset
       get_product_kind)
endif()

foreach( test ${tests_sanity} )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          LABELS       "sanity"
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh )
endforeach()
foreach( test ${tests_extra} )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          CONDITION    ENABLE_EXTRA_TESTS
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                          TEST_DEPENDS eccodes_download_gribs eccodes_download_bufrs eccodes_download_bufr_refs )
endforeach()

# Tests which are conditional
#############################
if( ENABLE_EXTRA_TESTS AND HAVE_ECCODES_THREADS )
    # For POSIX threads
    list(APPEND pthread_tests grib_pthreads bufr_pthreads)
    foreach( test ${pthread_tests} )
        ecbuild_add_executable( TARGET    c_${test}
                                NOINSTALL
                                SOURCES   ${test}.c
                                LIBS      eccodes ${CMAKE_THREAD_LIBS_INIT} )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                          TEST_DEPENDS eccodes_download_gribs eccodes_download_bufrs )
    endforeach()
endif()

# Tests with no script
######################
ecbuild_add_test(
    TARGET    eccodes_c_new_sample
    SOURCES   new_sample.c
    LIBS      eccodes
    ARGS      "out.grib"
    ENVIRONMENT "ECCODES_SAMPLES_PATH=${PROJECT_SOURCE_DIR}/samples" "ECCODES_DEFINITION_PATH=${PROJECT_SOURCE_DIR}/definitions"
)

=== examples/F90/CMakeLists.txt ===
# examples/F90/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )


# Add all the tests
####################
if( HAVE_BUILD_TOOLS )
    list( APPEND tests_sanity
          codes_ecc-1392
          codes_datetime_julian
          codes_set_paths
          codes_f90_misc
          grib_set_pv
          grib_set_data
          grib_set_data_force
          bufr_ecc-1284
          bufr_ecc-1019
          get_native_type
          grib_ecc-671 )
    list( APPEND tests_extra
          grib_index
          codes_dump
          codes_scan_file
          codes_load_file
          grib_copy_message
          grib_sections_copy
          bufr_copy_message
          grib_get_keys
          grib_get_data
          grib_get_data_real4
          grib_get_pl
          grib_get_pv
          grib_keys_iterator
          grib_keys_iterator_skip
          grib_multi_write
          grib_multi
          grib_elements
          grib_nearest
          grib_nearest_single
          grib_nearest_four_single
          grib_precision
          grib_print_data
          grib_set_keys
          grib_set_bitmap
          grib_set_missing
          grib_samples
          grib_count_messages
          grib_count_messages_multi
          grib_copy_namespace
          grib_read_message
          grib_read_from_file
          grib_read_bytes
          grib_get_set_uuid
          grib_clone
          grib_ecc-1316
          bufr_attributes
          bufr_copy_data
          bufr_clone
          bufr_expanded
          bufr_get_keys
          bufr_get_string_array
          bufr_keys_iterator
          bufr_read_header
          bufr_read_scatterometer
          bufr_read_synop
          bufr_read_temp
          bufr_read_tempf
          bufr_read_tropical_cyclone
          bufr_set_keys
          bufr_copy_keys
          bufr_subset
          get_product_kind )
else()
    # No command line tools
    list( APPEND tests_sanity
          grib_set_pv
          grib_set_data
          grib_set_data_force
          codes_set_paths
          codes_f90_misc
          get_native_type
          grib_ecc-671 )
    list( APPEND tests_extra
          grib_index
          grib_get_keys
          grib_get_data
          grib_get_pl
          grib_get_pv
          grib_keys_iterator
          grib_keys_iterator_skip
          grib_multi
          grib_nearest
          grib_elements
          grib_nearest_single
          grib_nearest_four_single
          grib_precision
          grib_print_data
          grib_set_missing
          grib_samples
          grib_count_messages
          grib_count_messages_multi
          grib_read_from_file
          grib_clone
          bufr_attributes
          bufr_clone
          bufr_expanded
          bufr_get_keys
          bufr_get_string_array
          bufr_keys_iterator
          bufr_read_header
          bufr_read_scatterometer
          bufr_read_synop
          bufr_read_temp
          bufr_read_tempf
          bufr_read_tropical_cyclone
          bufr_set_keys
          bufr_subset
          get_product_kind )
endif()

foreach( atest ${tests_sanity} )
    ecbuild_add_test( TARGET          eccodes_f_${atest}
                      SOURCES         ${atest}.f90
                      LINKER_LANGUAGE Fortran
                      LIBS            eccodes_f90 eccodes
                      CONDITION       HAVE_FORTRAN
                      LABELS          "sanity"
                      RESOURCES       bufr_read_scatterometer_f.ref
                      COMMAND         ${CMAKE_CURRENT_SOURCE_DIR}/${atest}.sh )
endforeach()
foreach( atest ${tests_extra} )
    ecbuild_add_test( TARGET          eccodes_f_${atest}
                      SOURCES         ${atest}.f90
                      LINKER_LANGUAGE Fortran
                      LIBS            eccodes_f90 eccodes
                      CONDITION       HAVE_FORTRAN AND ENABLE_EXTRA_TESTS
                      RESOURCES       bufr_read_scatterometer_f.ref
                      COMMAND         ${CMAKE_CURRENT_SOURCE_DIR}/${atest}.sh
                      TEST_DEPENDS    eccodes_download_gribs eccodes_download_bufrs eccodes_download_bufr_refs )
endforeach()

# Test for CCSDS (AEC) packing
ecbuild_add_test( TARGET          eccodes_f_grib_set_packing
                  SOURCES         grib_set_packing.f90
                  LINKER_LANGUAGE Fortran
                  LIBS            eccodes_f90 eccodes
                  CONDITION       HAVE_BUILD_TOOLS AND HAVE_AEC AND HAVE_FORTRAN
                  COMMAND         ${CMAKE_CURRENT_SOURCE_DIR}/grib_set_packing.sh )

# Executables without a shell script
ecbuild_add_executable( TARGET    eccodes_f_new_from_file
                        NOINSTALL
                        SOURCES   new_from_file.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes )
ecbuild_add_executable( TARGET    eccodes_f_grib_set_gvc
                        NOINSTALL
                        SOURCES   grib_set_gvc.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes )
ecbuild_add_executable( TARGET    eccodes_f_grib_print_data_static
                        NOINSTALL
                        SOURCES   grib_print_data_static.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes )


# # Note extra dependency
# ecbuild_add_test( TARGET eccodes_f_set_test
#                   TYPE SCRIPT
#                   DEPENDS set_gvc set
#                   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/set.sh
# )

=== debian/changelog ===
eccodes (2.34.1-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:54:54 +0000

eccodes (2.34.1-1build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:22:57 +0000

eccodes (2.34.1-1) unstable; urgency=medium

  * New upstream release
  
 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Feb 2024 07:16:39 +0000

eccodes (2.34.0-1) unstable; urgency=medium

  * New upstream release
  * Remove obsolete Breaks/Replaces/Conflicts from d/control
  * In dh rule, place env variables before not after the dh call,
    as otherwise parameters are messed (--no-parallel was being ignored
    leading to intermittent race  in gfortran mod creation)
  * Add fortran:Depends to d/control for libecccodes-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Feb 2024 10:00:01 +0000

=== debian/control ===
Source: eccodes
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-buildinfo, 
  dh-fortran-mod (>= 0.31),
  ecbuild (>= 3.7.0),
  libjpeg-dev, 
  libpng-dev, 
  flex, 
  bison, 
  quilt,
  swig, 
  doxygen,
  libboost-dev, 
  libhdf5-dev, 
  chrpath,
  libaec-dev,
  libnetcdf-dev,
  libopenjp2-7-dev
Build-Conflicts: libopenjpeg-dev, libeccodes-dev
Standards-Version: 4.6.2
Homepage: https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home
Vcs-Browser: https://salsa.debian.org:/science-team/eccodes.git
Vcs-Git: https://salsa.debian.org:/science-team/eccodes.git -b debian/latest

Package: libeccodes0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libeccodes-data
Description: GRIB and BUFR enecoding/encoding software library
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 It is a replacement for the grib-api and emoslib libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: GRIB and BUFR enecoding/encoding software library - data
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 
Package: libeccodes-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeccodes0 (= ${binary:Version}), 
  ${misc:Depends}, ${shlibs:Depends},  ${fortran:Depends},
  libaec-dev, libpng-dev, libjpeg-dev, zlib1g-dev
Description: GRIB and BUFR decoding/encoding software library (development)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
 
Package: libeccodes-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mksh | pdksh | zsh | ksh
Description: GRIB decoding/encoding software (utilities)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This is a useful set of command line tools to give quick access to grib
 messages.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: GRIB decoding/encoding software (documentation)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This provides the documentation for the library.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR=/usr/include/$(DEB_HOST_MULTIARCH)
DESTDIR=$(CURDIR)/debian/tmp
CMAKEDIR:=$(DESTDIR)/$(LIBDIR)/cmake/eccodes

BUILDDIR:=$(CURDIR)/debian/build
BUILDDIR_DEFAULT:=$(BUILDDIR)-$(FC_DEFAULT)

# For hardening
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) #  -fPIC
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)



export LDFLAGS CFLAGS CPPFLAGS CXXFLAGS

DO_TEST:=true

# Pull in ecbuild macros rather than local ones
BUILD_FLAGS =  \
	-DENABLE_INSTALL_ECCODES_DEFINITIONS=ON \
	-DENABLE_INSTALL_ECCODES_SAMPLES=ON \
	-DENABLE_PNG=ON \
	-DENABLE_AEC=ON \
	-DENABLE_RPATHS=OFF \
	-DENABLE_RELATIVE_RPATHS=OFF \
	-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}" \
	-DENABLE_ALIGN_MEMORY=ON \
	-DENABLE_GRIB_TIMER=ON \
	-DENABLE_ECCODES_OMP_THREADS=On  \

%:
	FC=$(FC_DEFAULT) dh $@ --buildsystem=ecbuild --builddirectory=${BUILDDIR_DEFAULT} \
		--no-parallel --with fortran_mod

override_dh_auto_configure:
	dh_auto_configure -- \
	    ${BUILD_FLAGS} 
	( cd ${BUILDDIR_DEFAULT}/data ; tar axpf $(CURDIR)/../eccodes_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )

override_dh_install:
	cd $(BUILDDIR_DEFAULT) && $(MAKE) install DESTDIR=$(DESTDIR)  
	# Move to multiarch dir
	mkdir -p  $(DESTDIR)/$(INCDIR)
	mv $(DESTDIR)/usr/include/*.h $(DESTDIR)/$(INCDIR)
	for d in libeccodes_f90.so	libeccodes.so ; do \
		chrpath -d $(DESTDIR)/$(LIBDIR)/$$d.0 ; done
	chrpath -d $(DESTDIR)/usr/bin/grib_to_netcdf
	dh_install
	# Setup cmake files for magics++, metview, etc.
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' 	$(CMAKEDIR)/eccodes-targets.cmake
	sed -i -e 's%/usr/lib/libeccodes%${LIBDIR}/libeccodes%' 			$(CMAKEDIR)/eccodes-targets-release.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}%/usr%'                  			$(CMAKEDIR)/eccodes-targets-release.cmake
	sed -i -e 's%${LIBDIR}/libopenjpeg.so;%%' 					$(CMAKEDIR)/eccodes-targets-release.cmake
	sed -i -e 's%;${LIBDIR}/libpng.so%%g' 						$(CMAKEDIR)/eccodes-targets-release.cmake
	sed -i -e 's%;${LIBDIR}/libopenjpeg.so%%g' 					$(CMAKEDIR)/eccodes-config.cmake
	sed -i -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake/eccodes%${LIBDIR}/cmake/eccodes%g' $(CMAKEDIR)/eccodes-config.cmake
	sed -i -e 's%;${LIBDIR}/libpng.so%%g' 						$(CMAKEDIR)/eccodes-config.cmake
	# For bit-reproducibility, sanitize the build paths
	for f in eccodes-config.cmake eccodes-import.cmake ; do \
		sed -i -e 's%${CURDIR}%/build/eccodes%g' $(CMAKEDIR)/$$f ; \
		sed -i -e 's%$${eccodes_BASE_DIR}/share%/usr/share%g' $(CMAKEDIR)/$$f ; \
		done
	# file exists on full builds only
	[ - e debian/libeccodes-dev/$(INCDIR)/eccodes_ecbuild_config.h ] && ( \
		sed -i -e 's%${CURDIR}%/build/eccodes%g'  debian/libeccodes-dev/$(INCDIR)/eccodes_ecbuild_config.h \
		) || true	

override_dh_auto_clean:
	dh_auto_clean
	# Things that upstream leaves behind
	rm -f configure.ac configure configure.in
	rm -f tests/bitmap.rules tests/out.grib1 tests/out.grib2 tests/out.gribidx \
	      tests/rules tests/simple_ieee_test.grib1.txt tests/statistics.filter \
	      tests/statistics.out tests/x.grib \
	      data/change_scanning_rotated_ll.filter examples/F90/index.idx

override_dh_fixperms:
	dh_fixperms
	test -e /usr/bin/dh_buildinfo && dh_buildinfo
	-chmod -x debian/libeccodes-dev/usr/share/doc/libeccodes-dev/examples/F90/include.sh
	-chmod +x debian/libeccodes-data/usr/share/eccodes/definitions/installDefinitions.sh

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=${BUILDDIR_DEFAULT}/lib dh_auto_test  ) || true
	# for f in $(FC_OPTIONAL) ; do \
	#  ( $(DO_TEST) && ( LD_LIBRARY_PATH=${BUILDDIR}-$$f/lib dh_auto_test  ) || true ) ; done
